#include "main.h"

void Alarm_Close(Widget   w,
		 Widget   PopupWidget, 
		 XmAnyCallbackStruct *call_value)
{
  XtUnrealizeWidget(PopupWidget);
}

void  SendAlarm(Appointment_Type *ATemp,
		Bool ReminderWarning)
     
{
  Widget Alarm_Popup;
  Widget Alarm_Frame;
  Widget Alarm_Form;
  Widget Alarm_Text;
  Widget Alarm_Label;
  Widget Alarm_Separator;
  Widget AlarmClose_Button;
  XmString LabelString;
  char Buffer[MY_BUFSIZ+1];

  XMapWindow(XtDisplay(W_TopLevel), 
	     XtWindow(W_TopLevel));
  
  Alarm_Popup = XtVaAppCreateShell("Alarm_Popup",
				   "Alarm_Popup",
				   applicationShellWidgetClass,
				   XtDisplay(W_TopLevel),
				   XmNtitle, "Alarm",
				   NULL,0); 
  
  Alarm_Frame = XtVaCreateManagedWidget("Alarm_Frame",
					xmFrameWidgetClass, 
					Alarm_Popup,
					NULL,0);
  
  Alarm_Form = XtVaCreateManagedWidget("Alarm_Form",
				       xmFormWidgetClass, 
				       Alarm_Frame,
				       NULL,0);
  
  if (ReminderWarning == True)
    {
      LabelString = XmStringCreate("APPOINTMENT REMINDER!", XmSTRING_DEFAULT_CHARSET),
      XBell(XtDisplay(W_TopLevel),100); 
      XBell(XtDisplay(W_TopLevel),100); 
    }
  else {
    LabelString = XmStringCreate("APPOINTMENT TIME REACHED!", XmSTRING_DEFAULT_CHARSET),
    XBell(XtDisplay(W_TopLevel),100); 
    XBell(XtDisplay(W_TopLevel),100); 
    XBell(XtDisplay(W_TopLevel),100); 
  }
  Alarm_Label = XtVaCreateManagedWidget("Alarm_Label",
					xmLabelWidgetClass, 
					Alarm_Form,
					XmNlabelString, LabelString,
					XmNleftAttachment, XmATTACH_FORM,
					XmNleftOffset, 10,
					XmNrightAttachment, XmATTACH_FORM,
					XmNrightOffset, 10,
					XmNtopAttachment, XmATTACH_POSITION,
					XmNtopPosition,0,
					XmNbottomAttachment, XmATTACH_POSITION,
					XmNbottomPosition,10,
					NULL,0);
  XmStringFree(LabelString);

  sprintf(Buffer,"%0-2d:%0-2d",ATemp->Hour,ATemp->Minutes);
  LabelString = XmStringCreate(Buffer, XmSTRING_DEFAULT_CHARSET),
  Alarm_Label = XtVaCreateManagedWidget("Alarm_Label",
					xmLabelWidgetClass, 
					Alarm_Form,
					XmNlabelString, LabelString,
					XmNleftAttachment, XmATTACH_FORM,
					XmNleftOffset, 10,
					XmNrightAttachment, XmATTACH_FORM,
					XmNrightOffset, 10,
					XmNtopAttachment, XmATTACH_POSITION,
					XmNtopPosition,10,
					XmNbottomAttachment, XmATTACH_POSITION,
					XmNbottomPosition,20,
					NULL,0);
  XmStringFree(LabelString);
  
  Alarm_Text = XmCreateScrolledText(Alarm_Form,
				    "Alarm_Text",
				    NULL,
				    0);
  XtVaSetValues(XtParent(Alarm_Text),
		XmNtopAttachment, XmATTACH_POSITION,
		XmNtopPosition,20,
		XmNbottomAttachment, XmATTACH_POSITION,
		XmNbottomPosition,80,
		XmNleftAttachment, XmATTACH_FORM,
		XmNleftOffset, 10,
		XmNrightAttachment, XmATTACH_FORM,
		XmNrightOffset, 10,
		NULL,0);
  
  XtVaSetValues(Alarm_Text,
		XmNrows, 8,
		XmNcolumns, 60,
		XmNeditable, False,
		XmNeditMode, XmMULTI_LINE_EDIT,
		XmNcursorPositionVisible, False,
		NULL,0);
  
  XmTextSetString(Alarm_Text,ATemp->Message);
  
  XtManageChild(Alarm_Text);
  
  Alarm_Separator = XtVaCreateManagedWidget("Alarm_Separator",
					    xmSeparatorWidgetClass,
					    Alarm_Form,
					    XmNleftAttachment, XmATTACH_FORM,
					    XmNrightAttachment, XmATTACH_FORM,
					    XmNtopAttachment, XmATTACH_POSITION,
					    XmNtopPosition,80,
					    XmNbottomAttachment, XmATTACH_POSITION,
					    XmNbottomPosition,85,
					    NULL,0);
  
  LabelString = XmStringCreate("Close", XmSTRING_DEFAULT_CHARSET),
  AlarmClose_Button = XtVaCreateManagedWidget("AlarmClose_Button",
					      xmPushButtonWidgetClass,
					      Alarm_Form,
					      XmNlabelString, LabelString,
					      XmNtopAttachment, XmATTACH_WIDGET, 
					      XmNbottomAttachment, XmATTACH_FORM,
					      XmNtopAttachment, XmATTACH_POSITION,
					      XmNtopPosition,85,
					      XmNbottomAttachment, XmATTACH_POSITION,
					      XmNbottomPosition,100,
					      XmNbottomOffset, 10,
					      XmNrightAttachment, XmATTACH_POSITION,
					      XmNrightPosition,55,
					      XmNleftAttachment, XmATTACH_POSITION,
					      XmNleftPosition,45,
					      NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AlarmClose_Button, XmNactivateCallback, 
                (XtCallbackProc) Alarm_Close, Alarm_Popup );
  
  /*   XtRealizeWidget(Alarm_Popup); */
  
  XWarpPointer(XtDisplay(Alarm_Popup),None,XtWindow(Alarm_Popup),0,0,0,0,1,1);
  XtPopup(Alarm_Popup, XtGrabNone);
}


void SetAlarms()

{
/*   fprintf(stderr,"SetAlarms\n"); */
  XtAppAddTimeOut(G_ApplicationContext,
		  30000,
		  (XtTimerCallbackProc) HandleAlarms,
		  NULL);
}

void HandleAlarms()

{
  Calendar_Type *Temp;
  Appointment_Type *ATemp;
  time_t Time_Enc;
  struct tm *Time_Struct;
  int CMin = 0 , AMin = 0;
  
  time(&Time_Enc);
  Time_Struct = localtime(&Time_Enc);
  
  if ((Time_Struct->tm_year >= 90) && (Time_Struct->tm_year <= 99))
      {

	/* this is a hack for the brain dead time structure that think years are only two digits */

	Time_Struct->tm_year  = Time_Struct->tm_year + 1900;
      }

/*   fprintf(stderr,"HandleAlarms\n"); */
/*  fprintf(stderr,"%d:%d  %d/%d/%d\n",Time_Struct->tm_hour,
	  Time_Struct->tm_min,
	  Time_Struct->tm_mday, 
	  Time_Struct->tm_mon+1, 
	  Time_Struct->tm_year);  
*/
  if (G_CalendarList != NULL)
    {
      Temp = G_CalendarList;
      while (Temp != NULL)
	{
	  if ((Time_Struct->tm_mday == Temp->Day) &&
	      ((Time_Struct->tm_mon+1) == Temp->Month) &&
	      (Time_Struct->tm_year == Temp->Year))
	    {
	      ATemp = Temp->Appointments;
	      while (ATemp != NULL)
		{
		  if (ATemp->ReminderAlarm == True)
		    {		
/*		      fprintf(stderr,"appointment: %d/%d/%d %d:%d\n",
			      Temp->Month,Temp->Day,Temp->Year,	
			      ATemp->Hour,ATemp->Minutes);
*/
		      
		      CMin = Time_Struct->tm_min + (Time_Struct->tm_hour * 60);
		      AMin = ATemp->Minutes + (ATemp->Hour  * 60);
		      
/* 		    fprintf(stderr,"C%d M%d W%d\n",AMin,CMin,ATemp->ReminderWarning); */
		      if ((AMin-CMin) == ATemp->ReminderWarning)
			{
/*			fprintf(stderr,"Reminder alarm found %d/%d/%d %d:%d\n",
				Temp->Month,Temp->Day,Temp->Year,
				ATemp->Hour,ATemp->Minutes);
*/
			  SendAlarm(ATemp,True);
			}
/* 		    fprintf(stderr,"CMin %d AMin %d\n", CMin, AMin); */
		      if ((Time_Struct->tm_min == ATemp->Minutes) &&
			  (Time_Struct->tm_hour == ATemp->Hour))
			{
/*			fprintf(stderr,"alarm found %d/%d/%d %d:%d\n",
				Temp->Month,Temp->Day,Temp->Year,
				ATemp->Hour,ATemp->Minutes);
*/
			  
			  SendAlarm(ATemp,False);
			}
		    }
		  ATemp = ATemp->Next;
		}
	    }
	  Temp = Temp->Next;
	}
    }
  SetAlarms();
}

