#include "main.h"

void  SendAlarm(char *AlarmMsgString,
		Bool ReminderWarning)
     
{
  Widget Alarm_Dialog;
  XmString AlarmXmString;
  XmString OkXmString;

/*  XIconifyWindow(XtDisplay(W_TopLevel),
		 XtWindow(W_TopLevel),
		 DefaultScreen(XtDisplay(W_TopLevel)));
  */

  XMapWindow(XtDisplay(W_TopLevel), 
	     XtWindow(W_TopLevel));
  
  AlarmXmString = XmStringLtoRCreate(AlarmMsgString, XmSTRING_DEFAULT_CHARSET);
  OkXmString = XmStringCreate("Close",XmSTRING_DEFAULT_CHARSET);

  Alarm_Dialog = XmCreateInformationDialog(W_TopLevel,
					   "Alarm",
					   NULL,0);
  XtVaSetValues(Alarm_Dialog,
                XmNmessageString, AlarmXmString,
		XmNokLabelString, OkXmString,
		NULL,0);

  XtVaSetValues(XtParent(Alarm_Dialog),
		XmNtitle, "Alarm",
		NULL,0);

  XmStringFree(AlarmXmString);
  XmStringFree(OkXmString);
  XtUnmanageChild((Widget )XmMessageBoxGetChild(Alarm_Dialog, XmDIALOG_HELP_BUTTON));
  XtUnmanageChild((Widget )XmMessageBoxGetChild(Alarm_Dialog, XmDIALOG_CANCEL_BUTTON));
  
  XtManageChild(Alarm_Dialog);
  XWarpPointer(XtDisplay(Alarm_Dialog),None,XtWindow(Alarm_Dialog),0,0,0,0,1,1);
  XBell(XtDisplay(W_TopLevel),100); 
  XtPopup(XtParent(Alarm_Dialog), XtGrabNone);
}


void SetAlarms()

{
  fprintf(stderr,"SetAlarms\n");
  XtAppAddTimeOut(G_ApplicationContext,
		  30000,
		  (XtTimerCallbackProc) HandleAlarms,
		  NULL);
}

void HandleAlarms()

{
  Calendar_Type *Temp;
  Appointment_Type *ATemp;
  time_t Time_Enc;
  struct tm *Time_Struct;
  int CMin = 0 , AMin = 0;
  
  time(&Time_Enc);
  Time_Struct = localtime(&Time_Enc);
  
  if ((Time_Struct->tm_year >= 90) && (Time_Struct->tm_year <= 99))
      {

	/* this is a hack for the brain dead time structure that think years are only two digits */

	Time_Struct->tm_year  = Time_Struct->tm_year + 1900;
      }

  fprintf(stderr,"HandleAlarms\n");
  fprintf(stderr,"%d:%d  %d/%d/%d\n",Time_Struct->tm_hour,
	  Time_Struct->tm_min,
	  Time_Struct->tm_mday, 
	  Time_Struct->tm_mon+1, 
	  Time_Struct->tm_year);  
  if (G_CalendarList == NULL)
    {
      fprintf(stderr,"Calendar list empty\n");
    }
  else {
    Temp = G_CalendarList;
    while (Temp != NULL)
      {
	if ((Time_Struct->tm_mday == Temp->Day) &&
	    ((Time_Struct->tm_mon+1) == Temp->Month) &&
	    (Time_Struct->tm_year == Temp->Year))
	  {
	    ATemp = Temp->Appointments;
	    while (ATemp != NULL)
	      {
		fprintf(stderr,"appointment: %d/%d/%d %d:%d\n",
			Temp->Month,Temp->Day,Temp->Year,
			ATemp->Hour,ATemp->Minutes);
		
		CMin = Time_Struct->tm_min + (Time_Struct->tm_hour * 60);
		AMin = ATemp->Minutes + (ATemp->Hour  * 60);

		if (abs(CMin-AMin) == ATemp->ReminderWarning)
		  {
		    fprintf(stderr,"Reminder alarm found %d/%d/%d %d:%d\n",
			    Temp->Month,Temp->Day,Temp->Year,
			    ATemp->Hour,ATemp->Minutes);
		    SendAlarm(ATemp->Message,True);
		  }
		fprintf(stderr,"CMin %d AMin %d\n", CMin, AMin);
		if ((Time_Struct->tm_min == ATemp->Minutes) &&
		    (Time_Struct->tm_hour == ATemp->Hour))
		  {
		    fprintf(stderr,"alarm found %d/%d/%d %d:%d\n",
			    Temp->Month,Temp->Day,Temp->Year,
			    ATemp->Hour,ATemp->Minutes);
		    SendAlarm(ATemp->Message,False);
		  }
		ATemp = ATemp->Next;
	      }
	  }
	Temp = Temp->Next;
      }
  }
  SetAlarms();
}

