#include "main.h"

Widget Appointment_Popup;
Widget Appointment_Frame;
Widget Appointment_Form;
Widget Appointment_Form2;
Widget Appointment_Separator;
Widget AppointmentAdd_Button;
Widget AppointmentUpdate_Button;
Widget AppointmentDelete_Button;
Widget AppointmentReset_Button;
Widget AppointmentClose_Button;
Widget AppointmentList_Label;
Widget AppointmentList_List;
Widget AppointmentAlarm_Toggle;
Widget AppointmentReminderWarning_Label;
Widget AppointmentReminderWarning_Text;
Widget AppointmentWeekly_Toggle;
Widget AppointmentMonthly_Toggle;
Widget AppointmentDate_Label;
Widget AppointmentTime_Label;
Widget AppointmentTime_Text;
Widget AppointmentMsg_Text;
Widget AppointmentMsg_Label;
Widget AppointmentIncrement_Arrow;
Widget AppointmentDecrement_Arrow;

int G_Current_Minutes  = 00;
int G_Current_Hour  = 12;

void Appointment_Close(Widget   w,
		       Widget   PopupWidget, 
		       XmAnyCallbackStruct *call_value)
{
  G_AppointmentFormVisible = False;
  XtUnrealizeWidget(PopupWidget);
/*  if (G_CurrentEntryInCalendarList->NumberOfAppointments == 0)
    {
      Delete_Date(G_CurrentEntryInCalendarList->Day,
		  G_CurrentEntryInCalendarList->Month,
		  G_CurrentEntryInCalendarList->Year);
    }
*/
}


void AppointmentForm_SetTime(int Hour,
			     int Minutes)
     
{
  char LabelBuffer[BUFSIZ];
  
  if ((Hour == 12) && (Minutes == 0))
    {
      sprintf(LabelBuffer,"%0-2d:%0-2d (Noon)",Hour,Minutes,
	      Minutes);
    }
  else
    if ((Hour == 00) && (Minutes == 0))
      {
	sprintf(LabelBuffer,"%0-2d:%0-2d (Midnight)",Hour,Minutes,
		Minutes);
      }
    else
      if (Hour == 12)
	{
	  sprintf(LabelBuffer,"%0-2d:%0-2d (12:%0-2d PM)",Hour,Minutes,
		  Minutes);
	}
      else
	if (Hour >= 13)
	  {
	    sprintf(LabelBuffer,"%0-2d:%0-2d (%0-2d:%0-2d PM)",Hour,Minutes,
		    Hour-12,Minutes);
	  }
	else {
	  sprintf(LabelBuffer,"%0-2d:%0-2d",Hour,Minutes);
	} 
  XmTextSetString(AppointmentTime_Text,LabelBuffer);
}


void Appointment_Add(Widget   w,
		     Widget   TextWidget, 
		     XmAnyCallbackStruct *call_value)
{
  struct Calendar_Struct DateEntry;
  struct Appointment_Struct AppointmentEntry;
  char *TempString;
  char *TimeString;
  char ListBuffer[255];
  XmString ListString;
  int lcv = 0;
  int ListBufferLen = 0;
  Appointment_Type *ATemp;
 
  TempString = XmTextGetString(AppointmentTime_Text);
  if (strstr(TempString,":") == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  TimeString = strtok(TempString,":");
  if (TimeString == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  if (strlen(TimeString) == 0)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  AppointmentEntry.Hour = atoi(TimeString);

  if ((AppointmentEntry.Hour > 24) || (AppointmentEntry.Hour < 0))
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }

  TimeString = strtok(NULL,":");
  if (TimeString == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  if (strlen(TimeString) == 0)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  AppointmentEntry.Minutes = atoi(TimeString);
  
  if ((AppointmentEntry.Minutes > 59) || (AppointmentEntry.Minutes < 0))
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  
  if (G_CurrentEntryInCalendarList != NULL)
    {
      ATemp = G_CurrentEntryInCalendarList->Appointments;
/*        fprintf(stderr,"Month/Day/Year %d/%d/%d\n",G_CurrentEntryInCalendarList->Month,G_CurrentEntryInCalendarList->Day,G_CurrentEntryInCalendarList->Year); */
      while (ATemp != NULL)
	{
	  if ((AppointmentEntry.Hour == ATemp->Hour ) &&
	      (AppointmentEntry.Minutes == ATemp->Minutes))
	    {
	      ErrorMessage("Insertion Error:\n\nAppointment already present.\nTry Update instead.\n");
	      return;
	    }
	  ATemp = ATemp->Next;
	}
    }
  
  TempString = XmTextGetString(AppointmentMsg_Text);
  if (strlen(TempString) == 0)
    {
      ErrorMessage("Message Error:\n\nMessage area is empty, appointment not added.\n");
      XtFree(TempString);
      return;
    }
  AppointmentEntry.Message = strdup(TempString);
  XtFree(TempString);
  
  AppointmentEntry.ReminderAlarm = XmToggleButtonGetState(AppointmentAlarm_Toggle);
  
  if (AppointmentEntry.ReminderAlarm == True)
    {
      TempString = XmTextGetString(AppointmentReminderWarning_Text);
      if (strlen(TempString) == 0)
	{
	  ErrorMessage("Message Error:\n\nReminder Warning area is empty, appointment not added.\n");
	  XtFree(TempString);
	  return;
	}
      AppointmentEntry.ReminderWarning = atoi(TempString);
      XtFree(TempString);
    }
  else {
    AppointmentEntry.ReminderWarning = REMINDER_WARNING;
  }
  
  
    /*   fprintf(stderr,"APPOINTMENT %d:%d -- %s",AppointmentEntry.Hour,AppointmentEntry.Minutes, */
      /* 	  AppointmentEntry.Message); */
      
      sprintf(ListBuffer,"%0-2d:%0-2d ",AppointmentEntry.Hour,AppointmentEntry.Minutes);
      
      ListBufferLen = strlen(ListBuffer);
      lcv = ListBufferLen;
      while ((AppointmentEntry.Message[lcv-ListBufferLen] != '\0') && (lcv < (70-ListBufferLen)))
    {
      ListBuffer[lcv] = AppointmentEntry.Message[lcv-ListBufferLen];
      lcv++;
    }
  ListBuffer[lcv] = '\0';

  ListString = XmStringCreate(ListBuffer, XmSTRING_DEFAULT_CHARSET);
  XmListAddItem(AppointmentList_List,ListString,0);
  XtVaGetValues(AppointmentList_List,
		XmNitemCount, &AppointmentEntry.ListPosition,
		NULL,0);
  
  AppointmentEntry.Repeat = 0;
  AppointmentEntry.RepeatForNumDays = REPEAT_NONE;
  DateEntry.Day = G_Current_Day;
  DateEntry.Month = G_Current_Month;
  DateEntry.Year = G_Current_Year;
  DateEntry.NumberOfAppointments = 0;
  DateEntry.Appointments = NULL;
  Add_Appointment(DateEntry,AppointmentEntry);
  G_ChangedNotSaved = True; 
  CreateAppointment_Form(DateEntry.Day,
			 DateEntry.Month,
			 DateEntry.Year);
}

void Appointment_Delete(Widget   w,
			Widget   TextWidget, 
			XmAnyCallbackStruct *call_value)
{
  int SelectedItemsCount = 0;
  int *SelectedItemsList = 0;
  Appointment_Type *ATemp;
  
  if (XmListGetSelectedPos(AppointmentList_List,&SelectedItemsList,&SelectedItemsCount) == False)
    {
      ErrorMessage("Deletion Error:\n\nNothing to delete, no appointment selected.\n");
      return;
    }
  
  ATemp = G_CurrentEntryInCalendarList->Appointments;
  while (ATemp != NULL)
    {
/*       fprintf(stderr,"%d %d\n",SelectedItemsList[0],ATemp->ListPosition); */
      if (SelectedItemsList[0] == ATemp->ListPosition)
	{
	  Delete_Appointment(G_CurrentEntryInCalendarList->Day,
			     G_CurrentEntryInCalendarList->Month,
			     G_CurrentEntryInCalendarList->Year,
			     ATemp->Hour,
			     ATemp->Minutes);
	  break;
	}
      ATemp = ATemp->Next;
    }
  CreateAppointment_Form(G_CurrentEntryInCalendarList->Day,
			 G_CurrentEntryInCalendarList->Month,
			 G_CurrentEntryInCalendarList->Year);
  G_ChangedNotSaved = True; 
}

void Appointment_Update(Widget   w,
			Widget   TextWidget, 
			XmAnyCallbackStruct *call_value)
{
  int SelectedItemsCount = 0;
  int *SelectedItemsList = 0;
  struct Appointment_Struct AppointmentEntry;
  char *TempString;
  char *TimeString;
  Appointment_Type *ATemp;
  Bool FoundAppointment = False;
  
  if (XmListGetSelectedPos(AppointmentList_List,&SelectedItemsList,&SelectedItemsCount) == False)
    {
      ErrorMessage("Update Error:\n\nNothing to update, no appointment selected.\n");
      return;
    }
  
  TempString = XmTextGetString(AppointmentTime_Text);
  if (strstr(TempString,":") == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  TimeString = strtok(TempString,":");
  if (TimeString == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  if (strlen(TimeString) == 0)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  AppointmentEntry.Hour = atoi(TimeString);

  if ((AppointmentEntry.Hour > 24) || (AppointmentEntry.Hour < 0))
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }

  TimeString = strtok(NULL,":");
  if (TimeString == NULL)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  if (strlen(TimeString) == 0)
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  AppointmentEntry.Minutes = atoi(TimeString);
  
  if ((AppointmentEntry.Minutes > 59) || (AppointmentEntry.Minutes < 0))
    {
      ErrorMessage("Time Format Error:\n\nTime must be in HOUR:MINUTE format.\nHours must be in 24 hour time.\n");
      XtFree(TempString);
      return;
    }
  
  if (G_CurrentEntryInCalendarList != NULL)
    {
      ATemp = G_CurrentEntryInCalendarList->Appointments;
      while (ATemp != NULL)
	{
	  if ((AppointmentEntry.Hour == ATemp->Hour ) &&
	      (AppointmentEntry.Minutes == ATemp->Minutes))
	    {
	      FoundAppointment = True;
	      break;
	    }
	  ATemp = ATemp->Next;
	}
    }
  
  if (FoundAppointment != True)
    {
      ErrorMessage("Update Error:\n\nAppointment not present.\nUse Add instead.\n"); 
      return;
    }
  
  TempString = XmTextGetString(AppointmentMsg_Text);
  if (strlen(TempString) == 0)
    {
      ErrorMessage("Message Error:\n\nMessage area is empty, appointment not added.\n");
      XtFree(TempString);
      return;
    }
  free(ATemp->Message);
  ATemp->Message = strdup(TempString);
  XtFree(TempString);

  ATemp->ReminderAlarm = XmToggleButtonGetState(AppointmentAlarm_Toggle);

  if (ATemp->ReminderAlarm == True)
    {
      TempString = XmTextGetString(AppointmentReminderWarning_Text);
      if (strlen(TempString) == 0)
	{
	  ErrorMessage("Message Error:\n\nReminder Warning area is empty, appointment not added.\n");
	  XtFree(TempString);
	  return;
	}
      ATemp->ReminderWarning = atoi(TempString);
      XtFree(TempString);
    }
  else {
      ATemp->ReminderWarning = REMINDER_WARNING;
  }

  ATemp->Hour = AppointmentEntry.Hour;
  ATemp->Minutes = AppointmentEntry.Minutes;
  ATemp->Repeat = REPEAT_NONE;
  ATemp->RepeatForNumDays = 0;
  G_ChangedNotSaved = True;
  CreateAppointment_Form(G_CurrentEntryInCalendarList->Day,
			 G_CurrentEntryInCalendarList->Month,
			 G_CurrentEntryInCalendarList->Year);
}

void Appointment_Reset(Widget   w,
		       Widget   TextWidget, 
		       XmAnyCallbackStruct *call_value)
{
  char Buffer[BUFSIZ];

  AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);
  XmTextSetString(AppointmentMsg_Text,"");
  XmToggleButtonSetState(AppointmentAlarm_Toggle,False,False);
  XtSetSensitive(AppointmentReminderWarning_Text,False);
  XtSetSensitive(AppointmentReminderWarning_Label,False);
  sprintf(Buffer,"%d",REMINDER_WARNING);
  XmTextSetString(AppointmentReminderWarning_Text,Buffer);
  XmListDeselectAllItems(AppointmentList_List);
}

void AppointmentTime_Increment(Widget   w,
			   Widget   TextWidget, 
			   XmAnyCallbackStruct *call_value)
{
  G_Current_Minutes += 15;
  if (G_Current_Minutes >= 60)
    {
      G_Current_Minutes = 0;
      G_Current_Hour++;
      if (G_Current_Hour >= 24)
	{
	  G_Current_Hour = 0;
	}
    }
  AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);
}

void AppointmentTime_Decrement(Widget   w,
			       Widget   TextWidget, 
			       XmAnyCallbackStruct *call_value)
{
  G_Current_Minutes -= 15;
  if (G_Current_Minutes < 0)
    {
      G_Current_Minutes = 45;
      G_Current_Hour--;
      if (G_Current_Hour < 0 )
	{
	  G_Current_Hour = 23;
	}
    }
  AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);
}

void AppointmentShowListItem(Widget   w,
			     XtPointer client_data,
			     XmListCallbackStruct *cbs)
{
  Appointment_Type *ATemp;
  int lcv = 1;
  char Buffer[BUFSIZ];
  
  if (G_CurrentEntryInCalendarList == NULL)
    {
      ErrorMessage("System Error:\n\nItem selected with no current entry in calendar list.\nThis should not happen.\n");
      return;
    }

/*   fprintf(stderr,"SEARCH %d %d\n",cbs->item_position,lcv); */
  ATemp = G_CurrentEntryInCalendarList->Appointments;
  while (ATemp != NULL)
    {
/*       fprintf(stderr,"SEARCH %d %d\n",cbs->item_position,lcv); */
      if (cbs->item_position == lcv)
	{
	  break;
	}
      ATemp = ATemp->Next;
      lcv++;
    }

  AppointmentForm_SetTime(ATemp->Hour,ATemp->Minutes);
  XmTextSetString(AppointmentMsg_Text,ATemp->Message);
  XmToggleButtonSetState(AppointmentAlarm_Toggle,ATemp->ReminderAlarm,False);
  if (ATemp->ReminderAlarm == True)
    {
      XtSetSensitive(AppointmentReminderWarning_Text,True);
      XtSetSensitive(AppointmentReminderWarning_Label,True);
    }
  else {
      XtSetSensitive(AppointmentReminderWarning_Text,False);
      XtSetSensitive(AppointmentReminderWarning_Label,False);
  }
  sprintf(Buffer,"%d",ATemp->ReminderWarning);
  XmTextSetString(AppointmentReminderWarning_Text,Buffer);
}

void ToggleReminderWarning(Widget w)
{
  if (XmToggleButtonGetState(w) == True)
    {
      XtSetSensitive(AppointmentReminderWarning_Text,True);
      XtSetSensitive(AppointmentReminderWarning_Label,True);
    }
  else {
      XtSetSensitive(AppointmentReminderWarning_Text,False);
      XtSetSensitive(AppointmentReminderWarning_Label,False);
  }
}

void  CreateAppointment_Form(int Day,
			     int Month,
			     int Year)
{
  char LabelBuffer[BUFSIZ];
  XmString LabelString;
  char ListBuffer[255];
  XmString ListString;
  int lcv = 0;
  int ListBufferLen = 0;
  Calendar_Type *CalTemp;
  Bool FoundDate = False;
  Appointment_Type *ATemp;

  CalTemp = G_CalendarList;
  while (CalTemp != NULL)
    {
      if ((Year == CalTemp->Year) &&
	  (Month == CalTemp->Month) && 
	  (Day == CalTemp->Day))
	{
	  FoundDate = True;
	  break;
	}
      CalTemp = CalTemp->Next;
    }
  
/*   Print_List(); */

  if (G_AppointmentFormVisible == True)
    {
      AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);
      XmTextSetString(AppointmentMsg_Text,"");
      XmToggleButtonSetState(AppointmentAlarm_Toggle,False,False);
      XmListDeleteAllItems(AppointmentList_List);
      
      if (FoundDate == True)
	{
	  G_CurrentEntryInCalendarList = CalTemp;
	  ATemp = CalTemp->Appointments;
	  while (ATemp != NULL)
	    {
	      sprintf(ListBuffer,"%0-2d:%0-2d ",ATemp->Hour,ATemp->Minutes);
	      ListBufferLen = strlen(ListBuffer);
	      lcv = ListBufferLen;
	      while ((ATemp->Message[lcv-ListBufferLen] != '\0') && (lcv < (70-ListBufferLen)))
		{
		  ListBuffer[lcv] = ATemp->Message[lcv-ListBufferLen];
		  lcv++;
		}
	      ListBuffer[lcv] = '\0';
	      
	      ListString = XmStringCreate(ListBuffer, XmSTRING_DEFAULT_CHARSET);
	      XmListAddItem(AppointmentList_List,ListString,0);
	      XtVaGetValues(AppointmentList_List,
			    XmNitemCount, &ATemp->ListPosition,
			    NULL,0);
	      
	      ATemp = ATemp->Next;
	    }
	}
      else {
	  G_CurrentEntryInCalendarList = NULL;
      }
      sprintf(LabelBuffer,"%s %d, %d",G_MonthNames[G_Current_Month-1],Day,Year);
      LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(AppointmentDate_Label,
		    XmNlabelString, LabelString,
		    NULL,0);
      XmStringFree(LabelString);
      AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);
      XmTextSetString(AppointmentMsg_Text,"");
      return;
    }
  G_AppointmentFormVisible = True;

  Appointment_Popup = XtVaAppCreateShell("Appointment_Popup",
					 "Appointment_Popup",
					 applicationShellWidgetClass,
					 XtDisplay(W_TopLevel),
					 XmNtitle, "Appointment Editor",
					 NULL,0); 
  
  Appointment_Frame = XtVaCreateManagedWidget("Appointment_Window",
					      xmFrameWidgetClass, 
					      Appointment_Popup,
					      NULL,0);
  
  Appointment_Form = XtVaCreateManagedWidget("Appointment_Form",
					     xmFormWidgetClass, 
					     Appointment_Frame,
					     NULL,0);
  
  sprintf(LabelBuffer,"%s %d, %d",G_MonthNames[G_Current_Month-1],Day,Year);
  LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET);
  AppointmentDate_Label = XtVaCreateManagedWidget("AppointmentDate_Label",
						  xmLabelWidgetClass, 
						  Appointment_Form,
						  XmNlabelString, LabelString,
						  XmNleftAttachment, XmATTACH_FORM,
						  XmNrightAttachment, XmATTACH_FORM,
						  XmNtopAttachment, XmATTACH_FORM,
						  XmNtopOffset, 15,
						  NULL,0);
  XmStringFree(LabelString);

  Appointment_Separator = XtVaCreateManagedWidget("Appointment_Separator",
						  xmSeparatorWidgetClass,
						  Appointment_Form,
						  XmNtopAttachment, XmATTACH_WIDGET, 
						  XmNtopWidget, AppointmentDate_Label,
						  XmNtopOffset, 10,
						  XmNleftAttachment, XmATTACH_FORM,
						  XmNrightAttachment, XmATTACH_FORM,
						  NULL,0);
  
  LabelString = XmStringCreate("Appointments: ", XmSTRING_DEFAULT_CHARSET),
  AppointmentList_Label = XtVaCreateManagedWidget("AppointmentList_Label",
						  xmLabelWidgetClass, 
						  Appointment_Form,
						  XmNlabelString, LabelString,
						  XmNtopAttachment, XmATTACH_WIDGET, 
						  XmNtopWidget, Appointment_Separator,
						  XmNleftAttachment, XmATTACH_FORM,
						  XmNrightAttachment, XmATTACH_FORM,
						  XmNrightOffset,10,
						  XmNleftOffset,10,
						  XmNtopOffset,5,
						  XmNalignment, XmALIGNMENT_BEGINNING,
						  NULL,0);
  XmStringFree(LabelString);
  AppointmentList_List = XmCreateScrolledList(Appointment_Form,
					  "AppointmentList_List",
					  NULL,0);
  XtAddCallback(AppointmentList_List, XmNbrowseSelectionCallback, 
                (XtCallbackProc) AppointmentShowListItem, NULL);
  
  XtVaSetValues(AppointmentList_List,
		XmNvisibleItemCount, 12,
		XmNselectionPolicy,XmBROWSE_SELECT,
		NULL,0);

  XtVaSetValues(XtParent(AppointmentList_List),
		XmNvisibleItemCount, 6,
		XmNleftAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftOffset, 10,
		XmNrightOffset, 10,
		XmNtopAttachment, XmATTACH_WIDGET, 
		XmNtopWidget, AppointmentList_Label,
		XmNtopOffset, 10,
		NULL,0);
  
  XtManageChild(AppointmentList_List);

  LabelString = XmStringCreate("Appointment Time: ", XmSTRING_DEFAULT_CHARSET),
  AppointmentTime_Label = XtVaCreateManagedWidget("AppointmentTime_Label",
						  xmLabelWidgetClass, 
						  Appointment_Form,
						  XmNlabelString, LabelString,
						  XmNtopAttachment, XmATTACH_WIDGET, 
						  XmNtopWidget, AppointmentList_List,
						  XmNtopOffset, 15,
						  XmNleftAttachment, XmATTACH_FORM,
						  XmNleftOffset, 10,
/* 						  XmNalignment, XmALIGNMENT_END, */
						  NULL,0);
  XmStringFree(LabelString);
  AppointmentTime_Text = XtVaCreateManagedWidget("AppointmentTime_Text",
						 xmTextFieldWidgetClass, 
						 Appointment_Form,
						 XmNleftAttachment, XmATTACH_WIDGET,
						 XmNleftWidget, AppointmentTime_Label,
						 XmNrightAttachment, XmATTACH_POSITION,
						 XmNrightPosition, 60,
						 XmNrightOffset,10,
						 XmNcolumns, 10,
						 XmNtopAttachment, XmATTACH_WIDGET,
						 XmNtopWidget, AppointmentList_List,
						 XmNtopOffset, 10,
						 XmNeditable, True,
						 NULL,0);
  AppointmentForm_SetTime(G_Current_Hour,G_Current_Minutes);

  AppointmentIncrement_Arrow = XtVaCreateManagedWidget("AppointmentIncrement_Arrow",
						       xmArrowButtonWidgetClass,
						       Appointment_Form,
						       XmNarrowDirection, XmARROW_UP,
						       XmNleftAttachment, XmATTACH_POSITION,
						       XmNleftPosition, 60,
						       XmNrightAttachment, XmATTACH_POSITION,
						       XmNrightPosition, 70,
						       XmNrightOffset,10,
						       XmNtopAttachment, XmATTACH_WIDGET,
						       XmNtopWidget, AppointmentList_List,
						       XmNtopOffset, 10,
						       NULL,0);
  XtAddCallback(AppointmentIncrement_Arrow, XmNactivateCallback, 
                (XtCallbackProc) AppointmentTime_Increment, NULL);
  
  AppointmentDecrement_Arrow = XtVaCreateManagedWidget("AppointmentDecrement_Arrow",
						       xmArrowButtonWidgetClass,
						       Appointment_Form,
						       XmNleftAttachment, XmATTACH_POSITION,
						       XmNleftPosition, 60,
						       XmNrightAttachment, XmATTACH_POSITION,
						       XmNrightPosition, 70,
						       XmNrightOffset,10,
						       XmNtopAttachment, XmATTACH_WIDGET,
						       XmNtopWidget, AppointmentIncrement_Arrow,
						       XmNarrowDirection, XmARROW_DOWN,
						       NULL,0);
  XtAddCallback(AppointmentDecrement_Arrow, XmNactivateCallback, 
                (XtCallbackProc) AppointmentTime_Decrement, NULL);

  LabelString = XmStringCreate("Set Alarm ", XmSTRING_DEFAULT_CHARSET),
  AppointmentAlarm_Toggle = XtVaCreateManagedWidget("AppointmentAlarm_Toggle",
						    xmToggleButtonWidgetClass, 
						    Appointment_Form,
						    XmNleftAttachment, XmATTACH_FORM,
						    XmNleftOffset, 10,
						    XmNtopAttachment, XmATTACH_WIDGET,
						    XmNtopWidget, AppointmentTime_Text,
						    XmNtopOffset, 15,
						    XmNalignment, XmALIGNMENT_BEGINNING,
						    XmNlabelString, LabelString,
						    NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentAlarm_Toggle, XmNvalueChangedCallback,  
                (XtCallbackProc)  ToggleReminderWarning, NULL);
  
  LabelString = XmStringCreate("Reminder Warning (in Minutes): ", XmSTRING_DEFAULT_CHARSET),
  AppointmentReminderWarning_Label = XtVaCreateManagedWidget("AppointmentReminderWarning_Label",
							     xmLabelWidgetClass, 
							     Appointment_Form,
							     XmNlabelString, LabelString,
							     XmNtopAttachment, XmATTACH_WIDGET, 
							     XmNtopWidget, AppointmentTime_Text,
							     XmNtopOffset, 20,
							     XmNleftAttachment, XmATTACH_WIDGET,
							     XmNleftWidget, AppointmentAlarm_Toggle,
							     NULL,0);
  XmStringFree(LabelString);
  XtSetSensitive(AppointmentReminderWarning_Label,False);

  AppointmentReminderWarning_Text = XtVaCreateManagedWidget("AppointmentReminderWarning_Text",
							    xmTextFieldWidgetClass, 
							    Appointment_Form,
							    XmNleftAttachment, XmATTACH_WIDGET,
							    XmNleftWidget, AppointmentReminderWarning_Label,
							    XmNcolumns, 10,
							    XmNtopAttachment, XmATTACH_WIDGET,
							    XmNtopWidget, AppointmentTime_Text,
							    XmNtopOffset, 15,
							    XmNeditable, True,
							    NULL,0);
  sprintf(LabelBuffer,"%d",REMINDER_WARNING);
  XmTextSetString(AppointmentReminderWarning_Text,LabelBuffer);
  XtSetSensitive(AppointmentReminderWarning_Text,False);


  Appointment_Form2 = XtVaCreateManagedWidget("Appointment_Form",
					      xmFormWidgetClass, 
					      Appointment_Form,
					      XmNfractionBase,3,
					      XmNleftAttachment, XmATTACH_FORM,
					      XmNrightAttachment, XmATTACH_FORM,
					      XmNtopAttachment, XmATTACH_WIDGET, 
					      XmNtopWidget, AppointmentReminderWarning_Text,
					      XmNtopOffset, 10,
					      NULL,0);
  
  LabelString = XmStringCreate("Message: ", XmSTRING_DEFAULT_CHARSET),
  AppointmentMsg_Label = XtVaCreateManagedWidget("AppointmentMsg_Label",
						 xmLabelWidgetClass, 
						 Appointment_Form,
						 XmNlabelString, LabelString,
						 XmNtopAttachment, XmATTACH_WIDGET, 
						 XmNtopWidget, Appointment_Form2,
						 XmNleftAttachment, XmATTACH_FORM,
						 XmNrightAttachment, XmATTACH_FORM,
						 XmNrightOffset,10,
						 XmNleftOffset,10,
						 XmNalignment, XmALIGNMENT_BEGINNING,
						 NULL,0);
  XmStringFree(LabelString);
  AppointmentMsg_Text = XtVaCreateManagedWidget("AppointmentMsg_Text",
						xmTextWidgetClass, 
						Appointment_Form,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNrightOffset,10,
						XmNleftOffset,10,
						XmNcolumns, 60,
						XmNrows, 10,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, AppointmentMsg_Label,
						XmNtopOffset, 5,
						XmNeditable, True,
						XmNeditMode, XmMULTI_LINE_EDIT,
						XmNwordWrap, True,
						NULL,0);
  
  Appointment_Separator = XtVaCreateManagedWidget("Appointment_Separator",
					     xmSeparatorWidgetClass,
					     Appointment_Form,
					     XmNtopAttachment, XmATTACH_WIDGET, 
					     XmNtopWidget, AppointmentMsg_Text,
					     XmNtopOffset, 10,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNrightAttachment, XmATTACH_FORM,
					     NULL,0);
  
  LabelString = XmStringCreate("Add", XmSTRING_DEFAULT_CHARSET),
  AppointmentAdd_Button = XtVaCreateManagedWidget("AppointmentAdd_Button",
						  xmPushButtonWidgetClass,
						  Appointment_Form,
						  XmNlabelString, LabelString,
						  XmNtopAttachment, XmATTACH_WIDGET, 
						  XmNbottomAttachment, XmATTACH_FORM,
						  XmNtopWidget, Appointment_Separator,
						  XmNtopOffset, 10,
						  XmNleftOffset, 10,
						  XmNbottomOffset, 10,
						  XmNleftAttachment, XmATTACH_POSITION,
						  XmNleftPosition,0,
						  XmNrightAttachment, XmATTACH_POSITION,
						  XmNrightPosition,20,
						  NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentAdd_Button, XmNactivateCallback, 
                (XtCallbackProc) Appointment_Add, NULL);
  

  LabelString = XmStringCreate("Update", XmSTRING_DEFAULT_CHARSET),
  AppointmentUpdate_Button = XtVaCreateManagedWidget("AppointmentUpdate_Button",
						 xmPushButtonWidgetClass,
						 Appointment_Form,
						 XmNlabelString, LabelString,
						 XmNtopAttachment, XmATTACH_WIDGET, 
						 XmNbottomAttachment, XmATTACH_FORM,
						 XmNtopWidget, Appointment_Separator,
						 XmNtopOffset, 10,
						 XmNbottomOffset, 10,
						 XmNleftAttachment, XmATTACH_POSITION,
						 XmNleftPosition,20,
						 XmNrightAttachment, XmATTACH_POSITION,
						 XmNrightPosition,40,
						 NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentUpdate_Button, XmNactivateCallback, 
                (XtCallbackProc) Appointment_Update, NULL);
  
  LabelString = XmStringCreate("Delete", XmSTRING_DEFAULT_CHARSET),
  AppointmentDelete_Button = XtVaCreateManagedWidget("AppointmentDelete_Button",
						 xmPushButtonWidgetClass,
						 Appointment_Form,
						 XmNlabelString, LabelString,
						 XmNtopAttachment, XmATTACH_WIDGET, 
						 XmNbottomAttachment, XmATTACH_FORM,
						 XmNtopWidget, Appointment_Separator,
						 XmNtopOffset, 10,
						 XmNbottomOffset, 10,
						 XmNleftAttachment, XmATTACH_POSITION,
						 XmNleftPosition,40,
						 XmNrightAttachment, XmATTACH_POSITION,
						 XmNrightPosition,60,
						 NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentDelete_Button, XmNactivateCallback, 
                (XtCallbackProc) Appointment_Delete, NULL);
  

  LabelString = XmStringCreate("Clear Form", XmSTRING_DEFAULT_CHARSET),
  AppointmentReset_Button = XtVaCreateManagedWidget("AppointmentReset_Button",
						    xmPushButtonWidgetClass,
						    Appointment_Form,
						    XmNlabelString, LabelString,
						    XmNtopAttachment, XmATTACH_WIDGET, 
						    XmNbottomAttachment, XmATTACH_FORM,
						    XmNtopWidget, Appointment_Separator,
						    XmNtopOffset, 10,
						    XmNbottomOffset, 10,
						    XmNleftAttachment, XmATTACH_POSITION,
						    XmNleftPosition,60,
						    XmNrightAttachment, XmATTACH_POSITION,
						    XmNrightPosition,80,
						    NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentReset_Button, XmNactivateCallback, 
                (XtCallbackProc) Appointment_Reset, NULL);
  
  
  LabelString = XmStringCreate("Close", XmSTRING_DEFAULT_CHARSET),
  AppointmentClose_Button = XtVaCreateManagedWidget("AppointmentClose_Button",
						    xmPushButtonWidgetClass,
						    Appointment_Form,
						    XmNlabelString, LabelString,
						    XmNtopAttachment, XmATTACH_WIDGET, 
						    XmNbottomAttachment, XmATTACH_FORM,
						    XmNtopWidget, Appointment_Separator,
						    XmNtopOffset, 10,
						    XmNrightOffset, 10,
						    XmNbottomOffset, 10,
						    XmNleftAttachment, XmATTACH_POSITION,
						    XmNleftPosition,80,
						    XmNrightAttachment, XmATTACH_POSITION,
						    XmNrightPosition,100,
						    NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(AppointmentClose_Button, XmNactivateCallback, 
                (XtCallbackProc) Appointment_Close, Appointment_Popup );


  if (FoundDate == True)
    {
      G_CurrentEntryInCalendarList = CalTemp;
      ATemp = CalTemp->Appointments;
      while (ATemp != NULL)
	{
	  sprintf(ListBuffer,"%0-2d:%0-2d ",ATemp->Hour,ATemp->Minutes);
	  ListBufferLen = strlen(ListBuffer);
	  lcv = ListBufferLen;
	  while ((ATemp->Message[lcv-ListBufferLen] != '\0') && (lcv < (70-ListBufferLen)))
	    {
	      ListBuffer[lcv] = ATemp->Message[lcv-ListBufferLen];
	      lcv++;
	    }
	  ListBuffer[lcv] = '\0';
	  
	  ListString = XmStringCreate(ListBuffer, XmSTRING_DEFAULT_CHARSET);
	  XmListAddItem(AppointmentList_List,ListString,0);
	  XtVaGetValues(AppointmentList_List,
			XmNitemCount, &ATemp->ListPosition,
			NULL,0);
	  ATemp = ATemp->Next;
	}
    }
   
  XtRealizeWidget(Appointment_Popup);
}

