#include "main.h"

Widget GotoMonth_Text;
Widget GotoYear_Text;

void Goto_Close(Widget   w,
		Widget   PopupWidget, 
		XmAnyCallbackStruct *call_value)
{
  XtUnrealizeWidget(PopupWidget);
}

void Goto_Confirm(Widget   w,
		  Widget   TextWidget, 
		  XmAnyCallbackStruct *call_value)
{
  char *MonthStr;
  char *YearStr;
  int Month = 0; 
  int Year = 0;
  
 
  MonthStr = XmTextFieldGetString(GotoMonth_Text);
  YearStr = XmTextFieldGetString(GotoYear_Text);
  Month  = atoi(MonthStr);
  Year   = atoi(YearStr);

/*   fprintf(stderr,"* %s *  %s * %d * %d * \n",MonthStr,YearStr,Month,Year); */
  
  if (Month > 12)
    {
      Month = 12;
    }
  if (Month < 1)
    {
      Month = 1;
    }
  if (Year > 9999)
    {
      Year = 9999;
    }
  if (Year < 1)
    {
      Year = 1;
    }
  G_Current_Year = Year;
  G_Current_Month = Month;
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  XtFree(MonthStr);
  XtFree(YearStr);
  if (G_DisplayYearlyViewVisible == True)
    {
      DrawYearCalendar();
    }
  if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void Goto_Reset(Widget   w,
		Widget   TextWidget, 
		XmAnyCallbackStruct *call_value)
{
  static char  Time_Str[80];
  time_t Time_Enc;
  struct tm *Time_Struct;

  time(&Time_Enc);
  Time_Struct = localtime(&Time_Enc);

  strftime(Time_Str,80,"%m",Time_Struct);
  XmTextFieldSetString(GotoMonth_Text,Time_Str);
  strftime(Time_Str,80,"%Y",Time_Struct);
  XmTextFieldSetString(GotoYear_Text,Time_Str);
}

void  Goto_Form()
{
  Widget Goto_Popup;
  Widget Goto_Frame;
  Widget Goto_Form;
  Widget Goto_Form2;
  Widget Goto_Label;
  Widget Goto_Separator;
  Widget GotoConfirm_Button;
  Widget GotoReset_Button;
  Widget GotoClose_Button;
  XmString LabelString;
  static char  Time_Str[80];
  time_t Time_Enc;
  struct tm *Time_Struct;
  
  
  
  time(&Time_Enc);
  Time_Struct = localtime(&Time_Enc);
  
  Goto_Popup = XtVaAppCreateShell("Goto_Popup",
				    "Goto_Popup",
				    applicationShellWidgetClass,
				    XtDisplay(W_TopLevel),
				    XmNtitle, "Goto",
				    NULL,0); 
  
  Goto_Frame = XtVaCreateManagedWidget("Goto_Window",
					 xmFrameWidgetClass, 
					 Goto_Popup,
					 NULL,0);
  
  Goto_Form = XtVaCreateManagedWidget("Goto_Form",
				      xmFormWidgetClass, 
				      Goto_Frame,
				      NULL,0);

  Goto_Form2 = XtVaCreateManagedWidget("Goto_Form",
				       xmFormWidgetClass, 
				       Goto_Form,
				       XmNfractionBase,4,
				       XmNleftAttachment, XmATTACH_FORM,
				       XmNrightAttachment, XmATTACH_FORM,
				       NULL,0);
  
  LabelString = XmStringCreate("Enter Month: ", XmSTRING_DEFAULT_CHARSET),
  Goto_Label = XtVaCreateManagedWidget("Goto_Label",
				       xmLabelWidgetClass, 
				       Goto_Form2,
				       XmNlabelString, LabelString,
				       XmNleftAttachment, XmATTACH_POSITION,
				       XmNleftPosition, 0,
				       XmNrightAttachment, XmATTACH_POSITION,
				       XmNrightPosition, 1,
				       XmNleftOffset, 5,
				       XmNtopAttachment, XmATTACH_FORM,
				       XmNtopOffset, 15,
				       NULL,0);
  XmStringFree(LabelString);

  GotoMonth_Text = XtVaCreateManagedWidget("GotoMonth_Text",
					   xmTextFieldWidgetClass, 
					   Goto_Form2,
					   XmNleftAttachment, XmATTACH_POSITION,
					   XmNleftPosition, 1,
					   XmNrightAttachment, XmATTACH_POSITION,
					   XmNrightPosition, 2,
					   XmNcolumns, 5,
					   XmNtopAttachment, XmATTACH_FORM,
					   XmNtopOffset, 10,
					   NULL,0);

  XtAddCallback(GotoMonth_Text, XmNactivateCallback, 
                (XtCallbackProc) Goto_Confirm, NULL);
  
  LabelString = XmStringCreate("Enter Year: ", XmSTRING_DEFAULT_CHARSET),
  Goto_Label = XtVaCreateManagedWidget("Goto_Label",
				       xmLabelWidgetClass, 
				       Goto_Form2,
				       XmNlabelString, LabelString,
				       XmNleftAttachment, XmATTACH_POSITION,
				       XmNleftPosition, 2,
				       XmNrightAttachment, XmATTACH_POSITION,
				       XmNrightPosition, 3,
				       XmNtopAttachment, XmATTACH_FORM,
				       XmNtopOffset, 15,
				       NULL,0);
  XmStringFree(LabelString);

  GotoYear_Text = XtVaCreateManagedWidget("GotoYear_Text",
					  xmTextFieldWidgetClass, 
					  Goto_Form2,
					  XmNleftAttachment, XmATTACH_POSITION,
					  XmNleftPosition, 3,
					  XmNrightAttachment, XmATTACH_POSITION,
					  XmNrightPosition, 4,
					  XmNtopAttachment, XmATTACH_FORM,
					  XmNtopOffset, 10,
					  XmNcolumns, 6,
					  XmNrightOffset, 5,
					  NULL,0);
  XtAddCallback(GotoYear_Text, XmNactivateCallback, 
                (XtCallbackProc) Goto_Confirm, NULL);
  
  strftime(Time_Str,80,"%m",Time_Struct);
  XmTextFieldSetString(GotoMonth_Text,Time_Str);
  strftime(Time_Str,80,"%Y",Time_Struct);
  XmTextFieldSetString(GotoYear_Text,Time_Str);

  Goto_Separator = XtVaCreateManagedWidget("Goto_Separator",
					     xmSeparatorWidgetClass,
					     Goto_Form,
					     XmNtopAttachment, XmATTACH_WIDGET, 
					     XmNtopWidget, GotoMonth_Text,
					     XmNtopOffset, 10,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNrightAttachment, XmATTACH_FORM,
					     NULL,0);
  
  LabelString = XmStringCreate("Goto", XmSTRING_DEFAULT_CHARSET),
  GotoConfirm_Button = XtVaCreateManagedWidget("GotoConfirm_Button",
						 xmPushButtonWidgetClass,
						 Goto_Form,
						 XmNlabelString, LabelString,
						 XmNtopAttachment, XmATTACH_WIDGET, 
						 XmNbottomAttachment, XmATTACH_FORM,
						 XmNtopWidget, Goto_Separator,
						 XmNtopOffset, 10,
						 XmNbottomOffset, 10,
						 XmNleftAttachment, XmATTACH_POSITION,
						 XmNleftPosition,25,
						 NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(GotoConfirm_Button, XmNactivateCallback, 
                (XtCallbackProc) Goto_Confirm, NULL);
  

  LabelString = XmStringCreate("Reset", XmSTRING_DEFAULT_CHARSET),
  GotoReset_Button = XtVaCreateManagedWidget("GotoReset_Button",
					       xmPushButtonWidgetClass,
					       Goto_Form,
					       XmNlabelString, LabelString,
					       XmNtopAttachment, XmATTACH_WIDGET, 
					       XmNbottomAttachment, XmATTACH_FORM,
					       XmNtopWidget, Goto_Separator,
					       XmNtopOffset, 10,
					       XmNbottomOffset, 10,
					       XmNleftAttachment, XmATTACH_POSITION,
					       XmNleftPosition,50,
					       NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(GotoReset_Button, XmNactivateCallback, 
                (XtCallbackProc) Goto_Reset, NULL);
  
  
  LabelString = XmStringCreate("Close", XmSTRING_DEFAULT_CHARSET),
  GotoClose_Button = XtVaCreateManagedWidget("GotoClose_Button",
					       xmPushButtonWidgetClass,
					       Goto_Form,
					       XmNlabelString, LabelString,
					       XmNtopAttachment, XmATTACH_WIDGET, 
					       XmNbottomAttachment, XmATTACH_FORM,
					       XmNtopWidget, Goto_Separator,
					       XmNtopOffset, 10,
					       XmNbottomOffset, 10,
					       XmNleftAttachment, XmATTACH_POSITION,
					       XmNleftPosition,75,
					       NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(GotoClose_Button, XmNactivateCallback, 
                (XtCallbackProc) Goto_Close, Goto_Popup );
  
  XtRealizeWidget(Goto_Popup);
}

