#include "main.h"

ReturnType Add_Date(struct Calendar_Struct AddEntry)
{
  Calendar_Type *Temp, *NewEntry, *Prev;
  int Counter;

  if (G_CalendarList == NULL)
    {
      if ((G_CalendarList = (Calendar_Type *)malloc(sizeof(Calendar_Type))) == NULL)
	{
	  return (RETURN_NOTOK);
	}
      G_CalendarList->Day = AddEntry.Day;
      G_CalendarList->Month = AddEntry.Month;
      G_CalendarList->Year = AddEntry.Year;
      G_CalendarList->NumberOfAppointments = AddEntry.NumberOfAppointments;
      G_CalendarList->Appointments = NULL;
      G_CalendarList->Next  = NULL;
      G_NumInCalendarList = 1;
      G_CurrentNumInCalendarList = 1;
      G_CurrentEntryInCalendarList = G_CalendarList;
    }
  else {
    Temp = G_CalendarList;
    Prev = NULL;
    Counter = 0;
    while (Temp != NULL)
      {
	Counter++;
	if (AddEntry.Year < Temp->Year)
	  {
	    if ((NewEntry = (Calendar_Type *)malloc(sizeof(Calendar_Type))) == NULL)
	      {
		return (RETURN_NOTOK);
	      }
	    NewEntry->Day = AddEntry.Day;
	    NewEntry->Month = AddEntry.Month;
	    NewEntry->Year = AddEntry.Year;
	    NewEntry->NumberOfAppointments = AddEntry.NumberOfAppointments;
	    NewEntry->Appointments = NULL;
	    NewEntry->Next  = NULL;
	    NewEntry->Next  = Temp;
	    if (Prev == NULL)
	      {
		G_CalendarList = NewEntry;
		G_CurrentNumInCalendarList = 1;
	      }
	    else {
	      Prev->Next = NewEntry;
	      G_CurrentNumInCalendarList = Counter;
	    }
	    G_CurrentEntryInCalendarList = NewEntry;
	    G_NumInCalendarList++;
	    return (RETURN_OK);
	  }
	Prev = Temp;
	Temp = Temp->Next;
      }
    if ((NewEntry = (Calendar_Type *)malloc(sizeof(Calendar_Type))) == NULL)
      {
	return (RETURN_NOTOK);
      }
    /*     fprintf(stderr,"add %s after of %s\n", AddEntry.Name,Prev->Name); */
    NewEntry->Day = AddEntry.Day;
    NewEntry->Month = AddEntry.Month;
    NewEntry->Year = AddEntry.Year;
    NewEntry->NumberOfAppointments = AddEntry.NumberOfAppointments;
    NewEntry->Appointments = NULL;
    NewEntry->Next  = NULL;
    Prev->Next = NewEntry;
    G_CurrentNumInCalendarList = Counter;
    G_CurrentEntryInCalendarList = NewEntry;
    G_NumInCalendarList++;
  }
  return (RETURN_OK);
}

ReturnType Add_Appointment(struct Calendar_Struct DateEntry,
			   struct Appointment_Struct AppointmentEntry)
{
  Calendar_Type *CalTemp;
  Appointment_Type *Temp, *NewEntry, *Prev;
  int Counter;
  int FoundDate = False;
  
 BEGINNING:
  if (G_CalendarList == NULL)
    {
      Add_Date(DateEntry);
      CalTemp = G_CalendarList;
      FoundDate = True;
/*       fprintf(stderr,"Could not find matching date for %d/%d/%d. Inserting at Beginning.\n", */
/* 	      DateEntry.Month,DateEntry.Day,DateEntry.Year); */
    }
  else {
    CalTemp = G_CalendarList;
    while (CalTemp != NULL)
      {
	if ((DateEntry.Year == CalTemp->Year) &&
	    (DateEntry.Month == CalTemp->Month) && 
	    (DateEntry.Day == CalTemp->Day))
	  {
	    FoundDate = True;
	    break;
	  }
	CalTemp = CalTemp->Next;
      }
  }
  if (FoundDate == False)
    {
/*       fprintf(stderr,"Could not find matching date for %d/%d/%d. Inserting.\n", */
/* 	      DateEntry.Month,DateEntry.Day,DateEntry.Year); */
      Add_Date(DateEntry);
      goto BEGINNING;
    }
  
  if (CalTemp->Appointments == NULL)
    {
      if ((CalTemp->Appointments = (Appointment_Type *)malloc(sizeof(Appointment_Type))) == NULL)
	{
	  return (RETURN_NOTOK);
	}
      /*        fprintf(stderr,"add %s to front of list\n", AppointmentEntry.Name);   */
      CalTemp->NumberOfAppointments = 1;
      CalTemp->Appointments->Hour = AppointmentEntry.Hour;
      CalTemp->Appointments->Minutes = AppointmentEntry.Minutes;
      CalTemp->Appointments->Message = strdup(AppointmentEntry.Message);
      CalTemp->Appointments->ReminderAlarm = AppointmentEntry.ReminderAlarm;
      CalTemp->Appointments->ReminderWarning = AppointmentEntry.ReminderWarning;
      CalTemp->Appointments->Repeat = AppointmentEntry.Repeat;
      CalTemp->Appointments->RepeatForNumDays = AppointmentEntry.RepeatForNumDays;
      CalTemp->Appointments->Next = NULL;
    }
  else {
    Temp = CalTemp->Appointments;
    Prev = NULL;
    Counter = 0;
    while (Temp != NULL)
      {
	Counter++;
	if ((AppointmentEntry.Hour < Temp->Hour) && 
	    (AppointmentEntry.Minutes < Temp->Minutes))
	    {
	    if ((NewEntry = (Appointment_Type *)malloc(sizeof(Appointment_Type))) == NULL)
	      {
		return (RETURN_NOTOK);
	      }
/*   	    fprintf(stderr,"add %d:%d in front of %d:%d\n",AppointmentEntry.Hour, */
/* 		    AppointmentEntry.Minutes,Temp->Hour,Temp->Minutes); */
	    NewEntry->Hour = AppointmentEntry.Hour;
	    NewEntry->Minutes = AppointmentEntry.Minutes;
	    NewEntry->Message = strdup(AppointmentEntry.Message);
	    NewEntry->ReminderAlarm = AppointmentEntry.ReminderAlarm;
	    NewEntry->ReminderWarning = AppointmentEntry.ReminderWarning;
	    NewEntry->Repeat = AppointmentEntry.Repeat;
	    NewEntry->RepeatForNumDays = AppointmentEntry.RepeatForNumDays;
	    NewEntry->Next  = Temp;
	    if (Prev == NULL)
	      {
		CalTemp->Appointments = NewEntry;
	      }
	    else {
	      Prev->Next = NewEntry;
	    }
	    CalTemp->NumberOfAppointments++;
	    return (RETURN_OK);
	  }
	Prev = Temp;
	Temp = Temp->Next;
	  }
    
    if ((NewEntry = (Appointment_Type *)malloc(sizeof(Appointment_Type))) == NULL)
      {
	return (RETURN_NOTOK);
      }
/*     fprintf(stderr,"add %d:%d after %d:%d\n",AppointmentEntry.Hour, */
/* 	    AppointmentEntry.Minutes,Prev->Hour,Prev->Minutes); */
    NewEntry->Hour = AppointmentEntry.Hour;
    NewEntry->Minutes = AppointmentEntry.Minutes;
    NewEntry->Message = strdup(AppointmentEntry.Message);
    NewEntry->ReminderAlarm = AppointmentEntry.ReminderAlarm;
    NewEntry->ReminderWarning = AppointmentEntry.ReminderWarning;
    NewEntry->Repeat = AppointmentEntry.Repeat;
    NewEntry->RepeatForNumDays = AppointmentEntry.RepeatForNumDays;
    NewEntry->Next  = NULL;
    Prev->Next = NewEntry;
    CalTemp->NumberOfAppointments++;
  }
  return (RETURN_OK);
}

ReturnType Print_List()
{
  Calendar_Type *Temp;
  Appointment_Type *ATemp;
  int Counter;

  if (G_CalendarList == NULL)
    {
      fprintf(stderr,"Calendar list empty\n");
    }
  else {
    Temp = G_CalendarList;
    Counter = 0;
    fprintf(stderr,"=====================================\n");
    while (Temp != NULL)
      {
	Counter++;
	fprintf(stderr,"Month/Day/Year %d/%d/%d\n",Temp->Month,Temp->Day,Temp->Year);
	fprintf(stderr,"NumberOfAppointment: %d\n",Temp->NumberOfAppointments);
	ATemp = Temp->Appointments;
	while (ATemp != NULL)
	  {
	    fprintf(stderr,"*****%d:%d %d %d  -- %s\n",ATemp->Hour,ATemp->Minutes,
		    ATemp->ReminderAlarm,ATemp->ReminderWarning,ATemp->Message);
	    ATemp = ATemp->Next;
	  }
	fprintf(stderr,"-------------------------------------\n");
	Temp = Temp->Next;
      }
    fprintf(stderr,"Number in list: %d\n",Counter);
    fprintf(stderr,"=====================================\n");
  }
  return (RETURN_OK);
}


ReturnType Update_Entry(struct Calendar_Struct UpdateEntry,
			int CurrentNum)
{
  Calendar_Type *Temp;
  int Counter;

  if (G_CalendarList == NULL)
    {
      return (RETURN_OK);
    }
  else {
    Temp = G_CalendarList;
    Counter = 1;
    while ((Temp != NULL) && (Counter < CurrentNum))
      {
	Temp = Temp->Next;
	Counter++;
      }
    if (Temp != NULL)
      {
	Temp->Year  = UpdateEntry.Year;
	Temp->Month  = UpdateEntry.Month;
	Temp->Day  = UpdateEntry.Day;
	Temp->NumberOfAppointments  = UpdateEntry.NumberOfAppointments;
      }
  }
  return (RETURN_OK);
}

ReturnType Delete_Date(int Day,
		       int Month,
		       int Year)
{
  Calendar_Type *Temp, *Prev;
  Appointment_Type *ATemp, *APrev;
  int Counter;

  if (G_CalendarList == NULL)
    {
      G_NumInCalendarList = 0;
      return (RETURN_OK);
    }
  else {
    Temp = G_CalendarList;
    Prev = NULL;
    Counter = 1;
    while (Temp != NULL)
      {
	Prev = Temp;
	if ((Day == Temp->Day) &&
	    (Month == Temp->Month) &&
	     (Year == Temp->Year))
	  {
	    break;
	  }
	Temp = Temp->Next;
	Counter++;
      }
    if (Counter == 1)
      {
        G_CurrentNumInCalendarList = 1;
	G_CurrentEntryInCalendarList = Temp->Next;
	G_CalendarList = Temp->Next;
	G_NumInCalendarList--;
	ATemp = Temp->Appointments;
        while (ATemp != NULL)
          {
	    free(ATemp->Message);
	    APrev = ATemp;
	    ATemp = ATemp->Next;
	    free(APrev);
	  }
	free(Temp);
      }
    else if (Temp != NULL)
      {
        G_CurrentNumInCalendarList = Counter;
	G_CurrentEntryInCalendarList = Temp->Next;
	Prev->Next = Temp->Next;
	G_NumInCalendarList--;
	ATemp = Temp->Appointments;
        while (ATemp != NULL)
          {
	    free(ATemp->Message);
	    APrev = ATemp;
	    ATemp = ATemp->Next;
	    free(APrev);
	  }
	free(Temp);
      }
  return (RETURN_OK);
  }
}

ReturnType Delete_All_Dates()

{
  Calendar_Type *Temp, *Prev;
  Appointment_Type *ATemp, *APrev;

  if (G_CalendarList == NULL)
    {
      G_NumInCalendarList = 0;
      return (RETURN_OK);
    }
  Temp = G_CalendarList;
  Prev = NULL;
  while (Temp != NULL)
    {
      ATemp = Temp->Appointments;
      while (ATemp != NULL)
	{
	  free(ATemp->Message);
	  APrev = ATemp;
	  ATemp = ATemp->Next;
	  free(APrev);
	}
      Prev = Temp;
      Temp = Temp->Next;
      free(Prev);
    }
  G_CurrentNumInCalendarList = 0;
  G_CurrentEntryInCalendarList = NULL;
  G_CalendarList = NULL;
  G_NumInCalendarList = 0;
  return (RETURN_OK);
}


ReturnType Delete_Appointment(int Day,
			      int Month,
			      int Year,
			      int Hour,
			      int Minutes)
{
  Calendar_Type *Temp, *Prev;
  Appointment_Type *ATemp, *APrev;
  int Counter;

  if (G_CalendarList == NULL)
    {
      G_NumInCalendarList = 0;
      return (RETURN_OK);
    }
  else {
    Temp = G_CalendarList;
    Prev = NULL;
    Counter = 1;
    while (Temp != NULL)
      {
	Prev = Temp;
	if ((Day == Temp->Day) &&
	    (Month == Temp->Month) &&
	     (Year == Temp->Year))
	  {
	    break;
	  }
	Temp = Temp->Next;
	Counter++;
      }
    if (Temp != NULL)
      {
	Temp->NumberOfAppointments--;
	ATemp = Temp->Appointments;
	APrev = NULL;
	if ((Hour == ATemp->Hour) &&
	    (Minutes == ATemp->Minutes))
	  {
	    Temp->Appointments = ATemp->Next;
	    free(ATemp->Message);
	    free(ATemp);
	  }
	else
	  while (ATemp != NULL)
	    {
	      if ((Hour == ATemp->Hour) &&
		  (Minutes == ATemp->Minutes))
		{
		  APrev->Next = ATemp->Next;
		  free(ATemp->Message);
		  free(ATemp);
		  break;
		}
	      else {
		APrev = ATemp;
		ATemp = ATemp->Next;
	      }
	    }
      }
    return (RETURN_OK);
  }
}

