#include "main.h"

void OK_OpenCalendar(Widget   w,
                    Widget   PopupWidget, 
                    XmFileSelectionBoxCallbackStruct *cbs)
{
  char *Filename;

  if (!XmStringGetLtoR(cbs->value,XmSTRING_DEFAULT_CHARSET,&Filename))
    {
      XtUnrealizeWidget(w);
      return;      
    }
  
  if (Filename == NULL)
    {
      XtUnrealizeWidget(w); /* no filename given */
      XtFree(Filename);
      return;      
    }
  free(G_Calendar_Filename);
  G_Calendar_Filename = strdup(Filename);
  Delete_All_Dates();

  Read_Calendar(G_Calendar_Filename);
  if (G_CalendarList != NULL)
    {
      G_CurrentNumInCalendarList = 1;
      G_CurrentEntryInCalendarList = G_CalendarList;
    }
  XtUnrealizeWidget(w);
  XtFree(Filename);
  Set_Calendar_Filename();
  return;  
}

void CANCEL_OpenCalendar(Widget   w,
                        Widget   PopupWidget, 
                        XmAnyCallbackStruct *cbs)
{
  XtUnrealizeWidget(w);
  return;
}

void Open_Calendar_Dialog()
{
  Widget W_FileDialog;

  G_OpenCalendar = False;
  W_FileDialog = (Widget) XmCreateFileSelectionDialog(W_TopLevel,"FileSelector",NULL,0);
  XtAddCallback(W_FileDialog, XmNcancelCallback, (XtCallbackProc) CANCEL_OpenCalendar,NULL);
  XtAddCallback(W_FileDialog, XmNokCallback, (XtCallbackProc) OK_OpenCalendar,NULL);
  XtUnmanageChild((Widget )XmFileSelectionBoxGetChild(W_FileDialog, XmDIALOG_HELP_BUTTON));
  XtVaSetValues(XtParent(W_FileDialog),
                XmNtitle,"XmCalendar File Selector",
                XmNgeometry, "480x400",
                NULL,0);
  XtManageChild(W_FileDialog);
}

void  Open_Calendar(Widget   w,
		    Widget   textwidget,   
		    XmAnyCallbackStruct *call_value)
{
  G_OpenCalendar = True;
  if (G_AppointmentFormVisible == True)
    {
      ErrorMessage("Error:\n\nAppointment Editor Open.\nPlease close before opening another calendar.\n");
      return;
    }
  if (G_ChangedNotSaved == True)
    {
      SaveDontExit(NULL,NULL,NULL);
    }
  else {
    Open_Calendar_Dialog();
  }
}

