#define PROTOTYPE_H

/* file.c */

ReturnType Read_Help_File();
ReturnType Read_Calendar(char *Filename);
ReturnType Write_Calendar(char *Filename);

/* quit.c */

void  Exit_Program(Widget   w,
		   Widget   textwidget,   
		   XmAnyCallbackStruct *call_value);
void SaveAndExit(Widget   w,
		 Widget   textwidget,   
		 XmAnyCallbackStruct *call_value);
void SaveDontExit(Widget   w,
		 Widget   textwidget,   
		 XmAnyCallbackStruct *call_value);


/* menu.c */

Widget BuildPulldownMenu(Widget parent,
			 char *menu_title, 
			 char menu_mnemonic,
			 MenuItem *items,
			 Bool IsHelpMenu);

/* help.c */

void  Display_Version(Widget   w,
		      Widget   textwidget,   
		      XmAnyCallbackStruct *call_value);
void Display_Help();


/* goto.c */

void  Goto_Form();

/* appointment.c */

void  CreateAppointment_Form(int Day,
			     int Month,
			     int Year);

/* error_msg.c */

void  ErrorMessage(char *ErrorMessageString);
void  InfoMessage(char *InfoMessageString);

/* year.c */

void DrawYearCalendar();
void DisplayYearlyView();


/* main.c */

void DisplayMonth_Calendar(int Month,
			   int Year);
void Set_Calendar_Filename();

/* alarm.c */

void SetAlarms();
void HandleAlarms();

/* open.c */

void  Open_Calendar(Widget   w,
		    Widget   textwidget,   
		    XmAnyCallbackStruct *call_value);

/* list.c */


ReturnType Delete_Appointment(int Day,
			      int Month,
			      int Year,
			      int Hour,
			      int Minutes);
ReturnType Delete_All_Dates();
ReturnType Delete_Date(int Day,
		       int Month,
		       int Year);
ReturnType Update_Entry(struct Calendar_Struct UpdateEntry,
			int CurrentNum);
ReturnType Print_List();
ReturnType Add_Appointment(struct Calendar_Struct DateEntry,
			   struct Appointment_Struct AppointmentEntry);
ReturnType Add_Date(struct Calendar_Struct AddEntry);
