#include "main.h"

Widget DisplayYearlyView_DA;
Widget DisplayYearlyView_Label;
GC GraphicContext;
XGCValues GraphicContextValues;

int LastX,LastY,LastWidth,LastHeight;

typedef struct MonthBox_Struct {
  int x,y,width,height;
} MonthBox_Type;

char DaysOfWeek[][3] = {"Su", "M ","Tu","W ","Th","F ","Sa" };

MonthBox_Type MonthBoxList[12];

void DrawYearCalendar()
{
  Pixel FG;
  int lcv, lcv2,lcv3,lcv4 = 0;
  int Month = 0;
  Dimension Height = 0;
  Dimension Width = 0;
  int w2,h2;
  int HOffset = 0;
  int WOffset = 0;
  int days[42];
  XmString LabelString;
  Pixmap DisplayYearlyView_Pixmap;
  char LabelBuffer[MY_BUFSIZ+1];
  

  /* get size of drawing area */

  XtVaGetValues(DisplayYearlyView_DA,
		XmNwidth, &Width,
		XmNheight, &Height,
		NULL,0);

  /* create pixmap */

  DisplayYearlyView_Pixmap = XCreatePixmap(XtDisplay(DisplayYearlyView_DA),
					   XtWindow(DisplayYearlyView_DA),
					   Width,
					   Height,
					   DefaultDepthOfScreen(XtScreen(DisplayYearlyView_DA)));
  
  /* create graphic context */

  GraphicContextValues.foreground = BlackPixelOfScreen(XtScreen(DisplayYearlyView_DA));
  GraphicContextValues.background = WhitePixelOfScreen(XtScreen(DisplayYearlyView_DA));
  GraphicContext = XCreateGC(XtDisplay(DisplayYearlyView_DA), 
			     RootWindowOfScreen(XtScreen(DisplayYearlyView_DA)),
			     GCForeground|GCBackground,&GraphicContextValues);

  
  XtVaSetValues(DisplayYearlyView_DA,
		XmNuserData,GraphicContext,
		NULL,0);
  

  /* clear window & pixmap */
  
	     
  FG = GraphicContextValues.foreground;
  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,GraphicContextValues.background);
  XSetFillStyle(XtDisplay(DisplayYearlyView_DA),GraphicContext,FillSolid);
  XFillRectangle(XtDisplay(DisplayYearlyView_DA),DisplayYearlyView_Pixmap,
		 GraphicContext,0,0,Width,Height);
  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,FG);
  
  XClearWindow(XtDisplay(DisplayYearlyView_DA),
	       XtWindow(DisplayYearlyView_DA));


  /* draw calendar */
  for (lcv= 1; lcv != 3; lcv++)
    {
      w2 = Width/3;
      XDrawLine(XtDisplay(DisplayYearlyView_DA),DisplayYearlyView_Pixmap,GraphicContext,
		w2*lcv,0,w2*lcv,Height);
    }
  for (lcv= 1; lcv != 4; lcv++)
    {
      h2 = Height/4;
      XDrawLine(XtDisplay(DisplayYearlyView_DA),DisplayYearlyView_Pixmap,GraphicContext,
		0,h2*lcv,Width,h2*lcv);
    }

  for (lcv4=0,lcv3 = 0,Month= 1; Month != 13; Month++, lcv3++)
    {
      if (lcv3 >= 3)
	{
	  lcv3 = 0;
	  lcv4++;
	}
      HOffset = (Height/4)*lcv4;
      WOffset = (Width/3)*lcv3; 
      MonthBoxList[Month-1].width = Width/3;
      MonthBoxList[Month-1].height = Height/4;
      MonthBoxList[Month-1].x = WOffset;
      MonthBoxList[Month-1].y = HOffset;
/*      fprintf(stderr," box #%d %dx%d %dx%d\n",Month-1,
	      MonthBoxList[Month-1].x,
	      MonthBoxList[Month-1].y,
	      (MonthBoxList[Month-1].x + MonthBoxList[Month-1].width),
	      (MonthBoxList[Month-1].y + MonthBoxList[Month-1].height));
*/
      if (Month == G_Current_Month)
	{
	  FG = GraphicContextValues.foreground;
	  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,GraphicContextValues.background);
	  XDrawRectangle(XtDisplay(DisplayYearlyView_DA),
			 XtWindow(DisplayYearlyView_DA),
			 GraphicContext,
			 LastX+3,
			 LastY+3,
			 LastWidth-6,
			 LastHeight-6);
	  
	  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,FG);
	  
	  XDrawRectangle(XtDisplay(DisplayYearlyView_DA),
			 DisplayYearlyView_Pixmap,
			 GraphicContext,
			 MonthBoxList[Month-1].x+3,
			 MonthBoxList[Month-1].y+3,
			 MonthBoxList[Month-1].width-6,
			 MonthBoxList[Month-1].height-6);
	  
	  LastX = MonthBoxList[Month-1].x;
	  LastY = MonthBoxList[Month-1].y;
	  LastWidth = MonthBoxList[Month-1].width;
	  LastHeight = MonthBoxList[Month-1].height;
	}
      XDrawString(XtDisplay(DisplayYearlyView_DA),
		  DisplayYearlyView_Pixmap,
		  GraphicContext,
		  WOffset+20,HOffset+20,
		  G_MonthNames[Month-1],
		  strlen(G_MonthNames[Month-1]));
      XDrawString(XtDisplay(DisplayYearlyView_DA),
		  DisplayYearlyView_Pixmap,
		  GraphicContext,
		  WOffset+21,HOffset+20,
		  G_MonthNames[Month-1],
		  strlen(G_MonthNames[Month-1]));
      
      day_array(Month, G_Current_Year, days);
      for (lcv2 = 1,lcv = 0; lcv != 49; lcv++)
	{
	  if (lcv%7  == 0)
	    {
	      lcv2++;
	    }
	  w2 = 20+(20*(lcv%7))+WOffset;
	  h2 = 17*lcv2+HOffset;
/* 	  fprintf(stderr,"%dx%d %d %d %%%d %d C%d\n",Width,Height,w2,h2, */
/* 		  lcv%7,lcv,days[lcv]); */
	  if (lcv > 6 )
	    {
	      if (days [lcv-7] != -1)
		{
		  sprintf(LabelBuffer,"%d",days[lcv-7]);
		  XDrawString(XtDisplay(DisplayYearlyView_DA),
			      DisplayYearlyView_Pixmap,
			      GraphicContext,
			      w2,h2,
			      LabelBuffer,
			      strlen(LabelBuffer));
		}
	    }
	  else {
	    XDrawString(XtDisplay(DisplayYearlyView_DA),
			DisplayYearlyView_Pixmap,
			GraphicContext,
			w2,h2,
			DaysOfWeek[lcv],
			strlen(DaysOfWeek[lcv]));
	    XDrawString(XtDisplay(DisplayYearlyView_DA),
			DisplayYearlyView_Pixmap,
			GraphicContext,
			w2+1,h2,
			DaysOfWeek[lcv],
			strlen(DaysOfWeek[lcv]));
	  }
	}
    }
  
  XDrawRectangle(XtDisplay(DisplayYearlyView_DA),
		 DisplayYearlyView_Pixmap,
		 GraphicContext,
		 0,0,Width-1,Height-1);
  
  /* place pixmap onto drawing area */

  XSetWindowBackgroundPixmap(XtDisplay(DisplayYearlyView_DA),
			     XtWindow(DisplayYearlyView_DA),
			     DisplayYearlyView_Pixmap);

  XClearWindow(XtDisplay(DisplayYearlyView_DA),
	       XtWindow(DisplayYearlyView_DA));

  /* update year label */

  sprintf(LabelBuffer,"%d",G_Current_Year);
  LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET),
  XtVaSetValues (DisplayYearlyView_Label,
		 XmNlabelString, LabelString,
		 NULL,0);
  XmStringFree(LabelString);
}

void DisplayYearlyViewNextYear()
{
  G_Current_Year++;
  if (G_Current_Year > 9999)
    {
      G_Current_Year = 1;
    }
  DrawYearCalendar();
  G_Current_Day = 1;
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void DisplayYearlyViewPreviousYear()
{
  G_Current_Year--;
  if (G_Current_Year < 1)
    {
      G_Current_Year = 9999;
    }
  DrawYearCalendar();
  G_Current_Day = 1;
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void DisplaySelectedMonth(Widget W,
			  XtPointer data,
			  XmDrawingAreaCallbackStruct *cbs)
{
  Pixel FG;
  int lcv ;

  
  if ((cbs->event->xany.type != ButtonPress))
    {
      return;
    }
/*   fprintf(stderr,"pointer %d  %d \n",cbs->event->xbutton.x,cbs->event->xbutton.y); */
  for (lcv = 0;lcv != 12; lcv++)
    {
/*      fprintf(stderr," box #%d %dx%d %dx%d\n",lcv,
	      MonthBoxList[lcv].x,
	      MonthBoxList[lcv].y,
	      (MonthBoxList[lcv].x + MonthBoxList[lcv].width),
	      (MonthBoxList[lcv].y + MonthBoxList[lcv].height));
*/
      
      if ((cbs->event->xbutton.x > MonthBoxList[lcv].x) &&
	  (cbs->event->xbutton.y > MonthBoxList[lcv].y) &&
	  (cbs->event->xbutton.x < (MonthBoxList[lcv].x + MonthBoxList[lcv].width)) &
	  (cbs->event->xbutton.y < (MonthBoxList[lcv].y + MonthBoxList[lcv].height)))
	{
	  FG = GraphicContextValues.foreground;
	  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,GraphicContextValues.background);
	  XDrawRectangle(XtDisplay(DisplayYearlyView_DA),
			 XtWindow(DisplayYearlyView_DA),
			 GraphicContext,
			 LastX+3,
			 LastY+3,
			 LastWidth-6,
			 LastHeight-6);

	  XSetForeground(XtDisplay(DisplayYearlyView_DA),GraphicContext,FG);
	  
	  XDrawRectangle(XtDisplay(DisplayYearlyView_DA),
			 XtWindow(DisplayYearlyView_DA),
			 GraphicContext,
			 MonthBoxList[lcv].x+3,
			 MonthBoxList[lcv].y+3,
			 MonthBoxList[lcv].width-6,
			 MonthBoxList[lcv].height-6);

	  LastX = MonthBoxList[lcv].x;
	  LastY = MonthBoxList[lcv].y;
	  LastWidth = MonthBoxList[lcv].width;
	  LastHeight = MonthBoxList[lcv].height;
/*  	  fprintf(stderr,"found %d\n",lcv);  */
	  G_Current_Month = lcv+1;
	}
    }
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  G_Current_Day = 1;
  if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void DisplayYearlyView_Close(Widget   w,
			     Widget   PopupWidget, 
			     XmAnyCallbackStruct *call_value)
{
  G_DisplayYearlyViewVisible = False;
  XtUnrealizeWidget(PopupWidget); 
}

void DisplayYearlyView()
{

  Widget DisplayYearlyView_Popup;
  Widget DisplayYearlyView_Frame;
  Widget DisplayYearlyView_Form;
  Widget DisplayYearlyView_Separator;
  Widget DisplayYearlyViewClose_Button;
  Widget DisplayYearlyViewNext_Button;
  Widget DisplayYearlyViewPrev_Button;
  XmString LabelString;
  char LabelBuffer[MY_BUFSIZ+1];

  if (G_DisplayYearlyViewVisible == True)
    {
      DrawYearCalendar();
      return;
    }

  G_DisplayYearlyViewVisible = True;


  DisplayYearlyView_Popup = XtVaAppCreateShell("DisplayYearlyView_Popup",
					       "DisplayYearlyView_Popup",
					       applicationShellWidgetClass,
					       XtDisplay(W_TopLevel),
					       XmNtitle, "Year View",
					       NULL,0); 
  
  DisplayYearlyView_Frame = XtVaCreateManagedWidget("DisplayYearlyView_Frame",
						    xmFrameWidgetClass, 
						    DisplayYearlyView_Popup,
						    NULL,0);
  
  DisplayYearlyView_Form = XtVaCreateManagedWidget("DisplayYearlyView_Form",
						   xmFormWidgetClass, 
						   DisplayYearlyView_Frame,
						   NULL,0);
  
  DisplayYearlyViewPrev_Button = XtVaCreateManagedWidget("DisplayYearlyViewPrev_Button",
							 xmArrowButtonWidgetClass,
							 DisplayYearlyView_Form,
							 XmNarrowDirection, XmARROW_LEFT,
							 XmNleftAttachment, XmATTACH_POSITION,
							 XmNleftPosition,0,
							 XmNleftOffset,10,
							 XmNrightAttachment, XmATTACH_POSITION,
							 XmNrightPosition,10,
							 XmNtopAttachment, XmATTACH_POSITION,
							 XmNtopPosition, 2,
							 XmNbottomAttachment, XmATTACH_POSITION,
							 XmNbottomPosition, 8,
							 NULL,0);
  XtAddCallback(DisplayYearlyViewPrev_Button, XmNactivateCallback,  
		(XtCallbackProc)  DisplayYearlyViewPreviousYear, NULL);


  sprintf(LabelBuffer,"%d",G_Current_Year);
  LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET),
  DisplayYearlyView_Label = XtVaCreateManagedWidget("DisplayYearlyView_Label",
						    xmLabelWidgetClass, 
						    DisplayYearlyView_Form,
						    XmNlabelString, LabelString,
						    XmNleftAttachment, XmATTACH_POSITION,
						    XmNleftPosition,10,
						    XmNrightAttachment, XmATTACH_POSITION,
						    XmNrightPosition,90,
						    XmNtopAttachment, XmATTACH_POSITION,
						    XmNtopPosition, 0,
						    XmNbottomAttachment, XmATTACH_POSITION,
						    XmNbottomPosition, 10,
						    XmNalignment, XmALIGNMENT_CENTER,
						    NULL,0);
  XmStringFree(LabelString);

  DisplayYearlyViewNext_Button= XtVaCreateManagedWidget("DisplayYearlyViewNext_Button",
							xmArrowButtonWidgetClass,
							DisplayYearlyView_Form,
							XmNarrowDirection, XmARROW_RIGHT,
							XmNleftAttachment, XmATTACH_POSITION,
							XmNleftPosition,90,
							XmNrightAttachment, XmATTACH_POSITION,
							XmNrightPosition,100,
							XmNrightOffset,10,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 2,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 8,
							NULL,0);
  XtAddCallback(DisplayYearlyViewNext_Button, XmNactivateCallback,  
		(XtCallbackProc)  DisplayYearlyViewNextYear, NULL);

  


  DisplayYearlyView_Separator = XtVaCreateManagedWidget("DisplayYearlyView_Separator",
							xmSeparatorWidgetClass,
							DisplayYearlyView_Form,
							XmNleftAttachment, XmATTACH_FORM,
							XmNrightAttachment, XmATTACH_FORM,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 10,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 12,
							NULL,0);

  DisplayYearlyView_DA = XtVaCreateManagedWidget("DisplayYearlyView_DA",
						 xmDrawingAreaWidgetClass, 
						 DisplayYearlyView_Form,
						 XmNleftAttachment, XmATTACH_FORM,
						 XmNleftOffset, 10,
						 XmNrightAttachment, XmATTACH_FORM,
						 XmNrightOffset, 10,
						 XmNtopAttachment, XmATTACH_POSITION,
						 XmNtopPosition, 12,
						 XmNbottomAttachment, XmATTACH_POSITION,
						 XmNbottomPosition, 90,
						 NULL,0);
  XtAddCallback(DisplayYearlyView_DA, XmNinputCallback,  
		(XtCallbackProc)  DisplaySelectedMonth, NULL);

  
  DisplayYearlyView_Separator = XtVaCreateManagedWidget("DisplayYearlyView_Separator",
							xmSeparatorWidgetClass,
							DisplayYearlyView_Form,
							XmNleftAttachment, XmATTACH_FORM,
							XmNrightAttachment, XmATTACH_FORM,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 90,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 92,
							NULL,0);
  
  LabelString = XmStringCreate("Close", XmSTRING_DEFAULT_CHARSET),
  DisplayYearlyViewClose_Button = XtVaCreateManagedWidget("DisplayYearlyViewClose_Button",
							  xmPushButtonWidgetClass,
							  DisplayYearlyView_Form,
							  XmNlabelString, LabelString,
							  XmNtopAttachment, XmATTACH_WIDGET, 
							  XmNbottomAttachment, XmATTACH_FORM,
							  XmNbottomOffset, 10,
							  XmNleftAttachment, XmATTACH_POSITION,
							  XmNleftPosition,45,
							  XmNtopAttachment, XmATTACH_POSITION,
							  XmNtopPosition, 92,
							  XmNbottomAttachment, XmATTACH_POSITION,
							  XmNbottomPosition, 100,
							  NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(DisplayYearlyViewClose_Button, XmNactivateCallback, 
                (XtCallbackProc) DisplayYearlyView_Close, DisplayYearlyView_Popup );
  
  XtRealizeWidget(DisplayYearlyView_Popup);

  XtAddEventHandler(DisplayYearlyView_DA,ExposureMask,False,
                    (XtEventHandler) DrawYearCalendar, NULL );

  DrawYearCalendar();
}
